'''
	A Python Script which uses the Vichan JSON API
	to check for new replies in the threads included
	in the 'urls' Dictionary.
'''

import json
import time
import requests
import sys
from os import system
from datetime import datetime

if len(sys.argv) < 3:
	print("./{} <thread url> <wait time>\n".format(sys.argv[0]))
	exit(1)

# Notify user of new post
def notify_user(start,com):
	system('notify-send "{} posted:" "{}" --icon=dialog-information'.format('#' + str(start), com))

# Dictionary of URLs to watch for with their posts count.
urls = {sys.argv[1] : 0}


# Loop to initialize the number of posts of each thread
for url, count in urls.items():
	json_data = requests.get(url+'.json')
	data = json.loads(json_data.text)

	count = 0

	for comment in data['posts']:
		count = count + 1
	urls[url] = count


# Infinite Loop which checks for new replies in the threads after interval provided by the user
while True:
	for url, c in urls.items():
		json_data = requests.get(url+'.json')
		data = json.loads(json_data.text)	
		count = 0
	
		for comment in data['posts']:
			count = count + 1
		if count > c :
			diff = count - c;
			urls[url] = count
			notify_user(data['posts'][urls[url] - diff]['no'],data['posts'][count-1]['com'])
	time.sleep(float(sys.argv[2]))
